> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Update a form

PUT https://example.itential.io/json-forms/forms/{id}
Content-Type: application/json

Updates a previously created JSON form, based on a supplied document ID and an object of fields to update.

Reference: https://docs.itential.com/itential-cloud/api-reference/json-forms/update-form

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `id` (string, required) — The ID of the form.

### Body (application/json)

This endpoint expects an object.

- `options` (object, optional)
  - `created` (string, required)
  - `createdBy` (string, required)
  - `lastUpdated` (string, required)
  - `lastUpdatedBy` (string, required)
  - `name` (string, required)
  - `description` (string, required, nullable)
  - `struct` (object, required)
    - `type` (string, required)
    - `items` (list of object or object or object or object or object or object or object, required)
      - object
        - `nodeId` (string, required)
        - `type` (string, required)
        - `title` (string, required)
        - `items` (list of any or object or object or object or object or object or object, required)
          - object
            - `nodeId` (string, required)
            - `type` ("boolean", required)
            - `title` (string, required)
            - `description` (string, required)
            - `customKey` (string or boolean, optional)
            - `required` (boolean, optional)
            - `options` (object, optional)
            - `helper` (string, optional)
            - `default` (boolean, optional)
            - `enum` (list of object, optional)
            - `readOnly` (boolean, optional)
            - `widget` (string, optional)
          - object
            - `nodeId` (string, required)
            - `type` ("number", required)
            - `title` (string, required)
            - `description` (string, required)
            - `placeholder` (string, required)
            - `required` (boolean, required)
            - `customKey` (string or boolean, optional)
            - `widget` (string, optional)
            - `options` (object, optional)
            - `helper` (string, optional)
            - `validation` (map from string to any or list of any, optional)
            - `readOnly` (boolean, optional)
            - `minimum` (double, optional, nullable)
            - `maximum` (double, optional, nullable)
            - `default` (double, optional, nullable)
            - `disabled` (boolean, optional)
          - object
            - `nodeId` (string, required)
            - `type` ("string", required)
            - `title` (string, required)
            - `description` (string, required)
            - `placeholder` (string, required)
            - `required` (boolean, required)
            - `customKey` (string or boolean, optional)
            - `options` (object, optional)
            - `helper` (string, optional)
            - `pattern` (string, optional)
            - `validation` (map from string to any or list of any, optional)
            - `readOnly` (boolean, optional)
            - `binding` (boolean, optional)
            - `rel` (string, optional)
            - `targetPointer` (string, optional)
            - `format` (string, optional)
            - `minLength` (integer, optional)
            - `maxLength` (integer, optional)
            - `default` (string, optional)
            - `disabled` (boolean, optional)
          - object
            - `nodeId` (string, required)
            - `type` ("string", required)
            - `title` (string, required)
            - `description` (string, required)
            - `placeholder` (string, required)
            - `required` (boolean, required)
            - `customKey` (string or boolean, optional)
            - `widget` (string, optional)
            - `options` (object, optional)
            - `helper` (string, optional)
            - `pattern` (string, optional)
            - `validation` (map from string to any or list of any, optional)
            - `readOnly` (boolean, optional)
            - `format` (string, optional)
            - `minLength` (integer, optional)
            - `maxLength` (integer, optional)
            - `default` (string, optional)
            - `disabled` (boolean, optional)
          - object
            - `nodeId` (string, required)
            - `type` (string, required)
            - `title` (string, required)
            - `description` (string, required)
            - `required` (boolean, required)
            - `customKey` (string or boolean, optional)
            - `options` (object, optional)
            - `helper` (string, optional)
            - `placeholder` (string, optional)
            - `enum` (list of string or map from string to any, optional, default: [])
            - `enumNames` (list of object, optional, default: [])
            - `binding` (boolean, optional, default: false)
            - `pattern` (string, optional)
            - `rel` (string, optional)
            - `targetPointer` (string, optional)
            - `method` (string, optional, nullable)
            - `body` (object, optional)
            - `sourcePointer` (string, optional, nullable)
            - `sourceKeyPointer` (string, optional, nullable)
            - `labelKeyPointer` (string, optional, nullable)
            - `base` (string, optional, nullable)
            - `href` (string, optional, nullable)
            - `validation` (map from string to any or list of any, optional)
            - `readOnly` (boolean, optional)
            - `transformation` (string or map from string to any, optional, nullable)
            - `disabled` (boolean, optional)
            - `default` (string or list of string, optional)
            - `widget` (string, optional)
            - `radio` (boolean, optional)
            - `inline` (boolean, optional)
          - object
            - `nodeId` (string, required)
            - `type` ("string", required)
            - `title` (string, required)
            - `description` (string, required)
            - `helper` (string, optional)
            - `required` (boolean, optional)
            - `format` ("data-url", optional)
            - `customKey` (string or boolean, optional)
        - `required` (boolean or list of any, optional)
        - `options` (object, optional)
        - `description` (string, optional)
        - `helper` (string, optional)
        - `collapsed` (boolean, optional)
        - `readOnly` (boolean, optional)
        - `schemaOption` (boolean, optional)
        - `combinationType` (string, optional)
        - `widget` (string, optional)
        - `uniqueItems` (boolean, optional)
        - `minItems` (double, optional)
        - `maxItems` (double, optional)
        - `customKey` (string or boolean, optional)
      - object
        - `nodeId` (string, required)
        - `type` ("boolean", required)
        - `title` (string, required)
        - `description` (string, required)
        - `customKey` (string or boolean, optional)
        - `required` (boolean, optional)
        - `options` (object, optional)
        - `helper` (string, optional)
        - `default` (boolean, optional)
        - `enum` (list of object, optional)
          - `id` (string, optional)
          - `value` (boolean, optional)
        - `readOnly` (boolean, optional)
        - `widget` (string, optional)
      - object
        - `nodeId` (string, required)
        - `type` ("number", required)
        - `title` (string, required)
        - `description` (string, required)
        - `placeholder` (string, required)
        - `required` (boolean, required)
        - `customKey` (string or boolean, optional)
        - `widget` (string, optional)
        - `options` (object, optional)
        - `helper` (string, optional)
        - `validation` (map from string to any or list of any, optional)
        - `readOnly` (boolean, optional)
        - `minimum` (double, optional, nullable)
        - `maximum` (double, optional, nullable)
        - `default` (double, optional, nullable)
        - `disabled` (boolean, optional)
      - object
        - `nodeId` (string, required)
        - `type` ("string", required)
        - `title` (string, required)
        - `description` (string, required)
        - `placeholder` (string, required)
        - `required` (boolean, required)
        - `customKey` (string or boolean, optional)
        - `options` (object, optional)
        - `helper` (string, optional)
        - `pattern` (string, optional)
        - `validation` (map from string to any or list of any, optional)
        - `readOnly` (boolean, optional)
        - `binding` (boolean, optional)
        - `rel` (string, optional)
        - `targetPointer` (string, optional)
        - `format` (string, optional)
        - `minLength` (integer, optional)
        - `maxLength` (integer, optional)
        - `default` (string, optional)
        - `disabled` (boolean, optional)
      - object
        - `nodeId` (string, required)
        - `type` ("string", required)
        - `title` (string, required)
        - `description` (string, required)
        - `placeholder` (string, required)
        - `required` (boolean, required)
        - `customKey` (string or boolean, optional)
        - `widget` (string, optional)
        - `options` (object, optional)
        - `helper` (string, optional)
        - `pattern` (string, optional)
        - `validation` (map from string to any or list of any, optional)
        - `readOnly` (boolean, optional)
        - `format` (string, optional)
        - `minLength` (integer, optional)
        - `maxLength` (integer, optional)
        - `default` (string, optional)
        - `disabled` (boolean, optional)
      - object
        - `nodeId` (string, required)
        - `type` (string, required)
        - `title` (string, required)
        - `description` (string, required)
        - `required` (boolean, required)
        - `customKey` (string or boolean, optional)
        - `options` (object, optional)
        - `helper` (string, optional)
        - `placeholder` (string, optional)
        - `enum` (list of string or map from string to any, optional, default: [])
        - `enumNames` (list of object, optional, default: [])
        - `binding` (boolean, optional, default: false)
        - `pattern` (string, optional)
        - `rel` (string, optional)
        - `targetPointer` (string, optional)
        - `method` (string, optional, nullable)
        - `body` (object, optional)
        - `sourcePointer` (string, optional, nullable)
        - `sourceKeyPointer` (string, optional, nullable)
        - `labelKeyPointer` (string, optional, nullable)
        - `base` (string, optional, nullable)
        - `href` (string, optional, nullable)
        - `validation` (map from string to any or list of any, optional)
        - `readOnly` (boolean, optional)
        - `transformation` (string or map from string to any, optional, nullable)
        - `disabled` (boolean, optional)
        - `default` (string or list of string, optional)
        - `widget` (string, optional)
        - `radio` (boolean, optional)
        - `inline` (boolean, optional)
      - object
        - `nodeId` (string, required)
        - `type` ("string", required)
        - `title` (string, required)
        - `description` (string, required)
        - `helper` (string, optional)
        - `required` (boolean, optional)
        - `format` ("data-url", optional)
        - `customKey` (string or boolean, optional)
    - `nodeId` (string, optional)
    - `projectId` (string, optional)
  - `schema` (object, required)
    - `type` (string, required)
    - `title` (string, required)
    - `_id` (string, optional)
    - `uniqueItems` (boolean, optional)
    - `minItems` (double, optional)
    - `maxItems` (double, optional)
    - `description` (string, optional)
    - `required` (list of string, optional)
    - `readOnly` (boolean, optional)
    - `options` (object, optional)
    - `properties` (object, optional)
    - `items` (object, optional)
    - `anyOf` (list of object, optional)
    - `oneOf` (list of object, optional)
    - `allOf` (list of object, optional)
  - `uiSchema` (object, required)
  - `validationSchema` (object, required)
  - `bindingSchema` (object, required)
  - `version` (string, required)
  - `_id` (string, optional)
  - `tags` (list of string or map from string to any, optional)
  - `id` (string, optional)
  - `namespace` (object, optional, nullable)
    - `type` (any, optional)
    - `_id` (string, optional)
    - `name` (string, optional)
    - `accessControl` (object, optional)
      - `read` (list of string, optional)
      - `execute` (list of string, optional)
      - `write` (list of string, optional)
      - `manage` (list of string, optional)

## Response

### 200

A response object containing the request status and a message

- `status` (enum, optional)
  - Allowed values: `success`, `failure`
- `message` (string, optional)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "status": "success",
  "message": "Form updated"
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/json-forms/forms/id"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/json-forms/forms/id';
const options = {method: 'PUT', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/json-forms/forms/id"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/json-forms/forms/id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://example.itential.io/json-forms/forms/id")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://example.itential.io/json-forms/forms/id', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/json-forms/forms/id");
var request = new RestRequest(Method.PUT);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/json-forms/forms/id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```